﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Parallels RAS Web Portal Sample</title>
    <style type="text/css">
        .documentation{ color:#666; font-size: 11pt; }
    </style>

    <script type="text/javascript">

        g_host = '<%=Request.Url.Host%>';
        g_port = '<%=Request.Url.Port%>';
        g_sessionID = '<%=Session.SessionID%>';
        g_path = '<%=GetDetectionPath()%>';
        g_secure = '<%=GetbSSL()%>';

        function LaunchClient() {
            try {
                // create temporary anchor to emulate mailto click in new tab
                var anchor = window.parent.document.createElement("a");
                anchor.href = "tuxclient://?Command=GetVersion&Server=" + g_host + "&Port=" + g_port + "&Session=" + g_sessionID + "&Secure=" + g_secure + "&Path=" + g_path;
                alert(anchor.href);
                anchor.style.display = "none";
                anchor.appendChild(window.parent.document.createTextNode(""));
                window.parent.document.body.appendChild(anchor);

                if (anchor.click) {
                    anchor.click();
                    Refresh();
                    return;
                }

                // some browsers (chromium/linux) have trouble with anchor.click
                var clickEv = window.parent.document.createEvent("HTMLEvents");
                clickEv.initEvent("click", true, true);
                anchor.dispatchEvent(clickEv);
                Refresh();
            }
            catch (err) {
                alert("error! " + err.message);
            }
        }

        function Refresh() {
            for (var x = 0; x < 5; x++)
                setTimeout(function () { document.getElementById('TuxClientDetection').src = "Detection.aspx"; }, 3000);
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <h1 style="border-bottom-style:solid; border-bottom-color:Red;">Parallels RAS Web Portal Sample</h1>
        <h2>User Page</h2><a href="Admin.aspx">Switch to Administration Page</a>
        <br/><br/>
        <asp:Panel runat="server" ID="pnlPreLog">
        WebService URL &nbsp;<asp:TextBox ID="txtServiceUrl" runat="server" Width="350px"></asp:TextBox>
            <asp:Button ID="btnAccept" runat="server" OnClick="btnAccept_Click" Text="Accept" /><br />
            <asp:Label ID="lblWebserviceError" runat="server" Text=""></asp:Label>
        <p class="documentation">The Parallels RAS Web Service URL is needed so that the Cloud Portal Sample can connect to the Parallels RAS Web Service to get the application listings and other settings.</p>
        </asp:Panel>
        
        <asp:Panel runat="server" id="pnlDetails" Visible="False">
        <h4>GetModulesVersion()</h4>
        <p class="documentation">This method returns an xml with the Application Listing and Web Server version numbers.</p>
        <asp:Label ID="lblVersion" runat="server"></asp:Label>
        <hr />
        <br />
        <h4>GetListOfFarms()</h4>
        <p class="documentation">This method returns a dataset of the available farms. The following data is being passed for each farm: ID, Alias, Server Name, and Second Level Authentication on/off.</p>
        Available Farms<br />
        <asp:Label ID="lblFarms" runat="server"></asp:Label><br />
        <hr />
        </asp:Panel>
        <br />
        <asp:Panel runat="server" ID="pnlLogonType" Visible="false">
        <p class="documentation">Two types of logons are available: the New Auth Logon, which is the recommended method, and the Basic Logon.</p>
        <h4>Logon Type</h4>
        <asp:DropDownList ID="ddlLogonType" runat="server">
            <asp:ListItem Value="New Auth Logon"></asp:ListItem>
            <asp:ListItem Value="Basic Logon"></asp:ListItem>
        </asp:DropDownList>
        <asp:Button ID="btnLogonTypeSelect" runat="server" OnClick="btnLogonTypeSelect_Click" Text="Select" />
        </asp:Panel>
        
        <asp:Panel runat="server" id="pnlBasicLogon" Visible="False">
        <p class="documentation">The parameters for the Basic Logon method are the username, password, local IP, farm ID, and secure connection.</p>
        <h4>Basic Logon</h4>
        <table>
            <tr>
                <td style="height: 26px">Username</td>
                <td style="height: 26px"><asp:TextBox ID="txtUserName" runat="server"></asp:TextBox></td>
            </tr>
            <tr>
                <td>Password</td>
                <td><asp:TextBox ID="txtPassword" runat="server" TextMode="Password"></asp:TextBox></td></tr>
            <tr>
                <td>Farm ID</td>
                <td><asp:TextBox ID="txtFarmID" runat="server"></asp:TextBox></td></tr>
        </table>
            <asp:Button ID="btnLogOn" runat="server" Text="Log On" OnClick="btnLogOn_Click" /><br />
            <asp:Label ID="lblLoginResult" runat="server"></asp:Label><br />
            <hr />
        </asp:Panel>
        &nbsp;&nbsp;
        <br />
        
        <asp:Panel runat="server" id="pnlNewAuthLogon" Visible="False">
        <p class="documentation">
            The New Auth Logon makes use of the PerformLogin function which determines the next state of the authentication process. <br />
            This handles which next dialog (that is the next step) is supposed to be shown once the authentication process starts. <br />
            There are 7 states: INIT, CONNECT, IDENTIFY, PROVIDELOGON, PROVIDEACCINFO, CHANGEPWD, READY. <br />
            INIT, CONNECT, and IDENTIFY connects with the Web Service to initialise the authentication process and to check whether there were any changes in the settings.<br />
            The PROVIDELOGON state detects whether Authentication mode is Windows or One Time Password (OTP)<br />
            PROVIDEACCINFO state is used in second level authentication process when a new account needs to be created.<br />
            The CHANGEPWD state is fired when the user needs to change the password.<br />
            And finally, the READY state, which is fired when the authentication process is ready.
        </p>
        <h4>New Auth Logon(UserName, Ip, nLocalPort, FarmId, bSecure, Language) + Password</h4>
        <table>
            <tr>
                <td>IP</td>
                <td><asp:TextBox ID="txtNewAuthIP" runat="server"></asp:TextBox></td>
                <td class="documentation">The IP address of the user</td></tr>
            <tr>
                <td>Local Port</td>
                <td><asp:TextBox ID="txtNewAuthLocalPort" runat="server"></asp:TextBox></td>
                <td class="documentation">The Port number of the user</td></tr>
            <tr>
                <td>Secure</td>
                <td><asp:TextBox ID="txtNewAuthSecure" runat="server" Text="false"></asp:TextBox></td>
                <td class="documentation">(true/false) This is the equivalent to the Secure Logon checkbox in the Cloud Portal. Logging in with secure=true will set the default connection mode to 'SSL Mode', while logging in with secure=false will set the default connection mode to 'Regular Gateway'</td></tr>
            <tr>
                <td>Language</td>
                <td><asp:TextBox ID="txtNewAuthLang" runat="server" Text="en"></asp:TextBox></td>
                <td class="documentation">(en/de/ru/it/es/fr/jp/pt)</td></tr>
            <tr><td><br /></td><td><br /></td></tr>
            <tr>
                <td>Farm ID</td>
                <td><asp:TextBox ID="txtNewAuthFarmID" runat="server"></asp:TextBox></td>
                <td class="documentation">The ID of the Farm that the user will be connecting to.</td></tr>
            <tr>
                <td style="height: 26px">Username</td>
                <td style="height: 26px"><asp:TextBox ID="txtNewAuthUsername" runat="server"></asp:TextBox></td>
            </tr>
            <tr>
                <td>Password</td>
                <td><asp:TextBox ID="txtNewAuthPassword" runat="server"></asp:TextBox></td></tr>
            <tr>
                <td>Method</td>
                <td><asp:DropDownList ID="ddlNewAuthSelectedMethod" runat="server" Enabled="false">
                </asp:DropDownList></td>
                <td class="documentation">(Second Level Authentication)</td></tr>
            <tr>
                <td>Send</td>
                <td><asp:DropDownList ID="ddlNewAuthSend" runat="server" Enabled="false">
                <asp:ListItem Text="Email" Value="SMTP"></asp:ListItem>
                <asp:ListItem Text="SMS" Value="SMS"></asp:ListItem>
                </asp:DropDownList>
                <asp:Button ID="btnNewAuthSendOTP" runat="server" Text="Send OTP" OnClick="btnNewAuthSendOTP_Click" Enabled="false" /><br />
                </td>
                <td class="documentation">(Second Level Authentication)</td></tr>
            <tr>
                <td>OTP</td>
                <td><asp:TextBox ID="txtNewAuthOTP" runat="server" Enabled="false"></asp:TextBox></td>
                <td class="documentation">(Second Level Authentication)</td></tr>
            <tr>
                <td>OTPCC</td>
                <td><asp:TextBox ID="txtNewAuthOTPCC" runat="server" Enabled="false"></asp:TextBox></td>
                <td class="documentation">(Second Level Authentication)</td></tr>
        </table>
            <asp:Button ID="btnNewAuthLogon" runat="server" Text="Log On" OnClick="btnNewAuthLogOn_Click" /><br />
            <br />
            Message: <asp:Label ID="lblNewAuthIdentifyMessage" runat="server"></asp:Label><br />
            Logon: <asp:Label ID="lblNewAuthMessage" runat="server"></asp:Label><br />
            <hr />
        </asp:Panel>
        &nbsp;&nbsp;
        <br />

        <asp:Panel runat="server" id="pnlNewAuthNewUser" Visible="False">
        <h4>New Auth New User</h4>
        <p class="documentation">The NewAuthCreateAccount method, with the Full Name, Mobile number and Email address as parameters, is used to create an account.</p>
        <table>
            <tr>
                <td style="height: 26px">Username</td>
                <td style="height: 26px"><asp:TextBox ID="txtNewAuthNewUserUsername" runat="server"></asp:TextBox></td>
            </tr>
            <tr>
                <td>FullName</td>
                <td><asp:TextBox ID="txtNewAuthNewUserFullname" runat="server"></asp:TextBox></td></tr>
            <tr>
                <td>Mobile</td>
                <td><asp:TextBox ID="txtNewAuthNewUserMobile" runat="server"></asp:TextBox></td></tr>
            <tr>
                <td>Email</td>
                <td><asp:TextBox ID="txtNewAuthNewUserEmail" runat="server"></asp:TextBox></td></tr>
        </table>
            <asp:Button ID="btnNewAuthNewUserAdd" runat="server" Text="Add User" OnClick="btnNewAuthNewUserAdd_Click" /><br />
            <br />
            Message: <asp:Label ID="lblNewAuthNewUserMessage" runat="server"></asp:Label><br />
            <hr />
        </asp:Panel>
        &nbsp;&nbsp;
        <br />

        <asp:Panel runat="server" id="pnlNewAuthActivate" Visible="False">
        <h4>New Auth New User Activate</h4>
        <p class="documentation">The NewAuthActivateToken method, with the method type and activation code as parameters, is used to activate the token provided by the user.</p>
        <table>
            <tr>
                <td style="height: 26px">Activation Code</td>
                <td style="height: 26px"><asp:TextBox ID="txtNewAuthActCode" runat="server"></asp:TextBox></td>
            </tr>
            <tr>
                <td>Send</td>
                <td><asp:DropDownList ID="ddlNewAuthActSend" runat="server">
                <asp:ListItem Text="Email" Value="SMTP"></asp:ListItem>
                <asp:ListItem Text="SMS" Value="SMS"></asp:ListItem>
                </asp:DropDownList></td></tr>
        </table>
            <asp:Button ID="btnNewAuthActSend" runat="server" Text="Send Activation Code" OnClick="btnNewAuthActSend_Click" /><br />
            <br />
            <asp:Button ID="btnNewAuthActivate" runat="server" Text="Activate" OnClick="btnNewAuthActivate_Click" /><br />
            <br />
            Message: <asp:Label ID="lblNewAuthActMessage" runat="server"></asp:Label><br />
            <hr />
        </asp:Panel>
        &nbsp;&nbsp;
        <br />
        
        <asp:Panel runat="server" id="pnlRuntime" Visible="False">
        <h4>SetConnMode(Mode Index)</h4>
        <h4>GetConnMode()</h4>
        Current connection mode :
        <asp:Label ID="lblConnMode" runat="server"></asp:Label><br />
        <asp:DropDownList ID="cmbConnMode" runat="server">
            <asp:ListItem Value="0">Regular Gateway</asp:ListItem>
            <asp:ListItem Value="1">Direct Mode</asp:ListItem>
            <asp:ListItem Value="2">SSL Mode</asp:ListItem>
        </asp:DropDownList>
        <asp:Button ID="btnChangeMode" runat="server" OnClick="btnChangeMode_Click" Text="Change" /><br />
        <hr />
        
        <h4>GetFarmFolders()</h4>
        <p class="documentation">This method returns the list of Folders available for that farm connected to.</p>
        <asp:Button ID="btnFarmFolders" runat="server" OnClick="btnFarmFolders_Click" Text="Get Farm Folders" /><br />
        <br />
        <asp:Label ID="lblFarmFolders" runat="server"></asp:Label><br />
        <hr />
        
        <h4>GetAppList(Folder ID)</h4>
        <p class="documentation">This method returns the application listing in the form of an XML String.</p>
        <p class="documentation">To get the full application list, the folder ID parameter should be left empty;</p>
        <p class="documentation">To get the application list of the root folder, the folder ID parameter should be '0';</p>
        <p class="documentation">To get the application list of a particular folder, the folder ID parameter should be set to the id of that particular folder;</p>
            Farm Folder ID&nbsp;
        <asp:TextBox ID="txtFolderId" runat="server"></asp:TextBox><asp:Button ID="btnGetAppList" runat="server" OnClick="btnGetAppList_Click" Text="Get Application List" /><br />
        <br />
        <asp:Label ID="lblAppList" runat="server"></asp:Label><br />
        <asp:TreeView ID="tvAppList" Runat="server"></asp:TreeView>
        <hr />
        
        <asp:Panel runat="server" id="pnlUserProperties" Visible="False">
        <h4>NewAuthGetFavourites()</h4>
        <p class="documentation">This method returns an xml with a list of applications (in comma delimited form) that were marked as Favourites by the logged in user. The PerformLogin function needs to be called to authenticate with the Web Service before calling the NewAuthGetFavourites method.</p>
        <asp:Label ID="lblGetFavourites" runat="server"></asp:Label><br />
        <asp:Button ID="btnGetFavourites" runat="server" OnClick="btnGetFavourites_Click" Text="Get Favourites" /><br />
        <hr /><br />

         <h4>NewAuthUpdateFavourites(Data)</h4>
        <p class="documentation">This method is used to update the Favourites list. This allows the users to add or remove applications from the Favourites section. The PerformLogin function needs to be called to authenticate with the Web Service before calling the NewAuthUpdateFavourites method.</p>
        <p class="documentation">To update the favourites, the application IDs in comma delimited form needs to be entered in the following field. (e.g. 80,276,1871)</p>
        Data:
        <asp:TextBox ID="txtUpdateFavourites" runat="server"></asp:TextBox>
        <asp:Label ID="lblUpdateFavourites" runat="server"></asp:Label><br />
        <asp:Button ID="btnUpdateFavourites" runat="server" OnClick="btnUpdateFavourites_Click" Text="Update Favourites" /><br /><br />
        <hr />
        </asp:Panel>

        <h4>Launching applications</h4>
        <p class="documentation">Applications can be launched either by generating 2xa files or by generating URL Schemas.</p>

        <p class="documentation">URL Schemas parameters:</p>

        <p class="documentation">
        Launching Application:
        <br />
        E.g. tuxclient://?Command=LaunchApp&AppID=1851&Alias=&ConnType=0&ConnMode=0&Server=servername&Backup=&Port=80&UserName=tester3%402xtesting&EncPass=0ctc94I1Tt5CdNhpTfiNig%3d%3d&SessionID=0ADB153D-6E33-4C56-9E82-9D7052A0257E&Connect=YES&Save=NO
        </p>

        <table class="documentation" cellpadding="5px" border="1px">
        <tr>
        <td>Key</td>
        <td>Value</td>
        <td>Description</td>
        </tr>
        <tr>
        <td>“Command”</td>
        <td>LaunchApp</td>
        <td>A flag to let the application know what the intent is about</td>
        </tr>
        <tr>
        <td>“AppID”</td>
        <td>Int</td>
        <td>The Application Id to be launhced</td>
        </tr>
        <tr>
        <td>“Alias”</td>
        <td>String</td>
        <td>The Server’s Alias</td>
        </tr>
        <tr>
        <td>“ConnType”</td>
        <td>Int</td>
        <td>Connection type can be either 	2 : Standard RDP Connection OR  0 : RAS Connection</td>
        </tr>
        <tr>
        <td>“ConnMode”</td>
        <td>Int</td>
        <td>Can be one of the following:  	0 : Gateway Mode OR 1 : Direct Mode OR 2 : Gateway SSL OR 3 :  Direct SSL</td>
        </tr>
        <tr>
        <td>“Server”</td>
        <td>String</td>
        <td>The Server name</td>
        </tr>
        <tr>
        <td>“Backup”</td>
        <td>String</td>
        <td>The Secondary Server name</td>
        </tr>
        <tr>
        <td>“Port”</td>
        <td>Int</td>
        <td>The Port number</td>
        </tr>
        <tr>
        <td>“Username”</td>
        <td>String</td>
        <td>The username of the logged in user</td>
        </tr>
        <tr>
        <td>“EncPass”</td>
        <td>String</td>
        <td>The encrypted password of the logged in user</td>
        </tr>
        <tr>
        <td>“SessionID”</td>
        <td>String</td>
        <td>The RAS Session ID</td>
        </tr>
        <tr>
        <td>“Connect”</td>
        <td>Boolean</td>
        <td></td>
        </tr>
        <tr>
        <td>“Save”</td>
        <td>Boolean</td>
        <td></td>
        </tr>
        </table>
        <br />
        <p class="documentation">
        Launching Application with Advanced Security On:
        <br />
        E.g. tuxclient://?Command=Get2xa&Server=localhost&Port=81&Session=vsxta5mj2lk5k445edsdmx45&Secure=NO&Path=%2f2xWebPortalSample%2fGet2xa.ashx%3fid%3d1851%26app%3d2XClient%26guid%3d4c961f64-622f-49fc-b42b-96c1532c25bd
        </p>
        
        <table class="documentation" cellpadding="5px" border="1px">
        <tr>
        <td>Key</td>
        <td>Value</td>
        <td>Description</td>
        </tr>
        <tr>
        <td>“Command”</td>
        <td>Get2xa</td>
        <td>A flag to let the application know what the intent is about</td>
        </tr>
        <tr>
        <td>“Server”</td>
        <td>String</td>
        <td>The server where the Parallels RAS Web Portal is hosted on. Server can be specified by IP or by its local name.</td>
        </tr>
        <tr>
        <td>“Port”</td>
        <td>Int</td>
        <td>The port number of the Parallels RAS Web Portal</td>
        </tr>
        <tr>
        <td>“Session”</td>
        <td>String</td>
        <td>The IIS Session ID. This is used so that the Parallels Client can connect with the Web Portal using the same IIS Session ID to obtain the full 2xa file.</td>
        </tr>
        <tr>
        <td>“Secure”</td>
        <td>Boolean</td>
        <td>The SSL boolean value</td>
        </tr>
        <tr>
        <td>“Path”</td>
        <td>String</td>
        <td>The Path which the 2XClient needs to connect to in able to get the full 2xa file.</td>
        </tr>
        </table>


        <h5>Enter the application ID to generate the 2xa file or the url schema below:</h5>
        Application ID
        <asp:TextBox ID="txt2xaappID" runat="server"></asp:TextBox>
        <br />
        <h5>Generate 2XA file</h5>
        <asp:Button ID="btnGet2xa" runat="server" OnClick="btnGet2xa_Click" Text="Get 2xa File" /> 
        <asp:LinkButton ID="lnk2xafile" runat="server"></asp:LinkButton>
        <br />
        <h5>Generate URL Schema</h5>
        <asp:Button ID="btnGetURLSchema" runat="server" OnClick="btnGetURLSchema_Click" Text="Get URL Schema" />
        <div runat="server" id="UrlSchemaDIV"></div>
        <br />
        <asp:Button ID="btnGetURLSecure" runat="server" OnClick="btnGetURLSecure_Click" Text="Get URL Schema (Advanced Security)" />
        <div runat="server" id="AdvancedUrlSchemaDIV"></div>
        <br />
        <hr />
        
        <h4>GetVersion</h4>
        <p class="documentation">URL Schemas are also used to detect the Parallels Client:

        <br />
        E.g. tuxclient://?Command=GetVersion&Server=localhost&Port=81&Session=vsxta5mj2lk5k445edsdmx45&Secure=NO&Path=%2f2xWebPortalSample%2fDetection.aspx%3fapp%3d2XClient%26installed%3d1
        </p>
        
        <table class="documentation" cellpadding="5px" border="1px">
        <tr>
        <td>Key</td>
        <td>Value</td>
        <td>Description</td>
        </tr>
        <tr>
        <td>“Command”</td>
        <td>GetVersion</td>
        <td>A flag to let the application know what the intent is about</td>
        </tr>
        <tr>
        <td>“Server”</td>
        <td>String</td>
        <td>The server where the Parallels RAS Web Portal is hosted on. Server can be specified by IP or by its local name.</td>
        </tr>
        <tr>
        <td>“Port”</td>
        <td>Int</td>
        <td>The port number of the Parallels RAS Web Portal</td>
        </tr>
        <tr>
        <td>“Session”</td>
        <td>String</td>
        <td>The IIS Session ID</td>
        </tr>
        <tr>
        <td>“Secure”</td>
        <td>Boolean</td>
        <td>The SSL boolean value</td>
        </tr>
        <tr>
        <td>“Path”</td>
        <td>String</td>
        <td>The Path which the Parallels Client needs to connect to in able to get the full 2xa file.</td>
        </tr>
        </table>

        <br />
        <input id="btnGetVersion" onclick="LaunchClient();" type="button" value="Get Version" />     
        <asp:Button ID="btnRefresh" runat="server" OnClientClick="javascript:document.getElementById('TuxClientDetection').src = 'Detection.aspx';" Text="Refresh" /><br />
        <iframe id="TuxClientDetection" src="Detection.aspx" scrolling="no" frameborder="0" height="50px" width="450px"></iframe>   
        <br />
        <hr />

        <h4>GetImage(Application ID)</h4>
        <p class="documentation">
            This function is responsible for returning the Images depending on the Application ID provided. 
            The return value of this function is a string that contains a base64 binary of the image.
        </p> 
        Application ID
        <asp:TextBox ID="txtAppID" runat="server"></asp:TextBox>
        <asp:Button ID="btnGetImage" runat="server" OnClick="btnGetImage_Click" Text="Get Icon" /><br />
        <asp:Image ID="imgImage" runat="server" Visible="False" /><br />
        <hr />
    
        <h4>Logoff()</h4>
        <asp:Button ID="btnLogOut" runat="server" OnClick="btnLogOut_Click" Text="LogOut" />
        </asp:Panel>
      </div>
    </form>
</body>
</html>
